local GearEvaluator = _G.GearEvaluator
local GearEvaluator_AutoSets = GearEvaluator:NewModule("AutoSets", "AceHook-3.0")

function GearEvaluator_AutoSets:OnEnable()
  if (not GearEvaluator.db.char.bestscores) then
    GearEvaluator.db.char.bestscores = {}
  end

  self:SecureHook(GearEvaluator, 'UpdateScore')
  self:Hook(GearEvaluator, 'UpdateEvaluatorFunction')
end

function GearEvaluator_AutoSets:OnDisable()
  self:Unhook(GearEvaluator, 'UpdateEvaluatorFunction')
  self:Unhook(GearEvaluator, 'UpdateScore')
end

function GearEvaluator_AutoSets:UpdateScore(object, name)
  local setname, icon = GetEquipmentSetInfoByName(name)

  if (setname) then
    local oldscore = GearEvaluator.db.char.bestscores[name] or 0

    if(GearEvaluator.scores[name] > oldscore) then
      GearEvaluator:Print("Updating set "..name.." with new best score "..GearEvaluator.scores[name])
      SaveEquipmentSet(name, icon)
      GearEvaluator.db.char.bestscores[name] = GearEvaluator.scores[name]
    end
  end
end

function GearEvaluator_AutoSets:UpdateEvaluatorFunction(object, info, func)
  GearEvaluator.db.char.bestscores[name] = 0
end
